'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

function createCanvas(_ref) {
  var _ref$staticCanvas = _ref.staticCanvas,
      staticCanvas = _ref$staticCanvas === undefined ? false : _ref$staticCanvas,
      _ref$canvasBackground = _ref.canvasBackgroundColor,
      canvasBackgroundColor = _ref$canvasBackground === undefined ? '#999' : _ref$canvasBackground,
      _ref$getUsedWidth = _ref.getUsedWidth,
      getUsedWidth = _ref$getUsedWidth === undefined ? function () {
    return 0;
  } : _ref$getUsedWidth,
      _ref$getUsedHeight = _ref.getUsedHeight,
      getUsedHeight = _ref$getUsedHeight === undefined ? function () {
    return 0;
  } : _ref$getUsedHeight,
      _ref$htmlContainerHei = _ref.htmlContainerHeight,
      htmlContainerHeight = _ref$htmlContainerHei === undefined ? 0 : _ref$htmlContainerHei;

  var canvas = staticCanvas ? new fabric.StaticCanvas('canvas') : new fabric.Canvas('canvas');

  // apply background-color
  canvas.setBackgroundColor(canvasBackgroundColor);

  // resize the canvas to fill browser window dynamically
  function resizeCanvas() {
    canvas.setWidth(window.innerWidth - getUsedWidth());
    canvas.setHeight(window.innerHeight - getUsedHeight());
    canvas.renderAll();
  }
  resizeCanvas();

  $(window).resize((0, _lodash.debounce)(resizeCanvas, 10));

  return canvas;
} /* globals fabric $ */
exports.default = createCanvas;