'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = runStage;

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function runStage(monsterr) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$clientSide = _ref.clientSide;

  _ref$clientSide = _ref$clientSide === undefined ? {} : _ref$clientSide;
  var _ref$clientSide$comma = _ref$clientSide.commands,
      commands = _ref$clientSide$comma === undefined ? {} : _ref$clientSide$comma,
      _ref$clientSide$event = _ref$clientSide.events,
      events = _ref$clientSide$event === undefined ? {} : _ref$clientSide$event,
      setup = _ref$clientSide.setup,
      teardown = _ref$clientSide.teardown,
      _ref$options = _ref.options;
  _ref$options = _ref$options === undefined ? {} : _ref$options;
  var duration = _ref$options.duration,
      timeOnServer = _ref$options.timeOnServer;
  var onTimeout = arguments[2];

  function modifiedTeardown(monsterr) {
    var _monsterr$canvas;

    var byTimer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    teardown && teardown(monsterr);
    (_monsterr$canvas = monsterr.canvas).remove.apply(_monsterr$canvas, _toConsumableArray(monsterr.canvas.getObjects()));
    if (byTimer) {
      onTimeout && onTimeout();
    }
  }

  var timer = void 0;
  if (duration && !timeOnServer) {
    console.log('will timeout after', duration);
    timer = setTimeout(function () {
      return terminateStage(true);
    }, duration);
  }

  setup && setup(monsterr);

  var terminated = false;
  function terminateStage() {
    var byTimer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    if (terminated) {
      return;
    }
    terminated = true;

    if (timer) {
      clearTimeout(timer);
    }
    modifiedTeardown(monsterr, byTimer);
  }

  // We return a function that can be called to terminate the stage
  return {
    stopStage: function stopStage() {
      return terminateStage(false);
    },
    events: events,
    commands: commands
  };
}